	program rtp2dv
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Retrieve mantle part of dVsh/Vsh in the model SH18CE
c for given locations.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	integer maxfmax,maxnzpar,maxngrid
	parameter ( maxfmax = 18 )
	parameter ( maxnzpar = 14 )
	parameter ( maxngrid = 16200 )
c
	integer fmin,fmax,nzpar
	real*8 dm( (maxfmax*(maxfmax+2)+1)*maxnzpar )
	real*8 dep,lat,lon
c temporary variables
	real*8 hh(0:maxfmax*(maxfmax+2))
c
	data fmin,fmax / 0,18 /
c
	fmin = 0
	fmax = 18
c
	call readdm( maxfmax,fmin,fmax,nzpar,dm )
c
  100	continue
	  write(6,'(a15,$)') 'Dep, Lat, Lon ='
	  read(5,*) dep,lat,lon
	  if ( dep.lt.0.d0 ) goto 110
	  call dl2dv( maxfmax,fmin,fmax,nzpar,hh,dep,lat,lon,dm )
	  goto 100
  110	continue
c
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine readdm( maxfmax,fmin,fmax,nzpar,dm )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	integer maxfmax,fmin,fmax,nzpar
	real*8 dm((fmin-1)*(fmin+1)+1:fmax*(fmax+2),*)
	integer izpar,ipar,idum
c
	nzpar = 13
c
	open( unit=11,file='sh18ce.dat',status='old' )
c
	do 110 izpar=1,nzpar
	  do 100 ipar=(fmin-1)*(fmin+1)+1,fmax*(fmax+2)
	    read(11,*) idum,dm(ipar,izpar)
  100	  continue
  110	continue
c
	close(11)
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine dl2dv( maxfmax,fmin,fmax,nzpar,hh,dep,lat,lon,dm )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	real*8 pi
	parameter ( pi=3.1415926535897932d0 )
c
	integer maxfmax,fmin,fmax,nzpar
	real*8 hh(0:maxfmax*(maxfmax+2)),dep,lat,lon
	real*8 dm((fmin-1)*(fmin+1)+1:fmax*(fmax+2),*)
c other variables
	integer ipar,f,g,izpar
	real*8 xlm,h1,h2,theta,phi,rtheta,rphi,r,rho0,vs0,mu0
	real*8 zz1,zz2,pert,rpert
	real*8 rmax,PREM_vrmin(10),PREM_vrmax(10)
	real*8 model_node(14)
	real*8 PREM_rho(4,10),PREM_vs(4,10)
c
	data rmax / 6371.d0 /
	data PREM_vrmin /
     &	  3480.0, 3630.0, 5600.0, 5701.0, 5771.0,
     &	  5971.0, 6151.0, 6291.0, 6346.6, 6356.0
     &	  /
	data PREM_vrmax /
     &	  3630.0, 5600.0, 5701.0, 5771.0, 5971.0,
     &	  6151.0, 6291.0, 6346.6, 6356.0, 6368.0
     &	  /
	data PREM_rho /
     &	   7.9565,  -6.4761,   5.5283,  -3.0807,
     &	   7.9565,  -6.4761,   5.5283,  -3.0807,
     &	   7.9565,  -6.4761,   5.5283,  -3.0807,
     &	   5.3197,  -1.4836,   0.0000,   0.0000,
     &	  11.2494,  -8.0298,   0.0000,   0.0000,
     &	   7.1089,  -3.8045,   0.0000,   0.0000,
     &	   2.6910,   0.6924,   0.0000,   0.0000,
     &	   2.6910,   0.6924,   0.0000,   0.0000,
     &	   2.9000,   0.0000,   0.0000,   0.0000,
     &	   2.6000,   0.0000,   0.0000,   0.0000
     &	  /
	data PREM_vs /
     &	   6.9254,   1.4672,  -2.0834,   0.9783,
     &	  11.1671, -13.7818,  17.4575,  -9.2777,
     &	  22.3459, -17.2473,  -2.0834,   0.9783,
     &	   9.9839,  -4.9324,   0.0000,   0.0000,
     &	  22.3512, -18.5856,   0.0000,   0.0000,
     &	   8.9496,  -4.4597,   0.0000,   0.0000,
     &	  -1.0839,   5.7176,   0.0000,   0.0000,
     &	  -1.0839,   5.7176,   0.0000,   0.0000,
     &	   3.9000,   0.0000,   0.0000,   0.0000,
     &	   3.2000,   0.0000,   0.0000,   0.0000
     &	  /
	data model_node /
     &	  3480.0, 3981.0, 4431.0, 4821.0, 5161.0,
     &	  5451.0, 5701.0, 5841.0, 5971.0, 6091.0,
     &	  6211.0, 6301.0, 6346.6, 6368.0 /
c
c	write(6,*) '... Now generating xyz-file ...'
	if ( nzpar.ne.13 ) stop 'Inappropriate nzpar (genxyz).'
c
	ipar= (fmin-1)*(fmin+1)
	do 110 f=fmin,fmax
	do 100 g=-f,f
	  ipar = ipar + 1
	  hh(ipar) = 0.d0
	  if ( g.lt.0 ) then
	    h1 = 0.d0
	    h2 = (-1.d0)**(-g) * dsqrt(8.d0*pi)
	  endif
	  if ( g.eq.0 ) then
	    h1 = dsqrt(4.d0*pi)
	    h2 = 0.d0
c
	    if ( f.eq.0 ) h1 = 0.d0
c
	  endif
	  if ( g.gt.0 ) then
	    h1 = (-1.d0)**(g) * dsqrt(8.d0*pi)
	    h2 = 0.d0
	  endif
	  theta = 90.d0 - lat
	  rtheta = theta * pi / 180.d0
	  phi = lon
	  rphi = phi * pi / 180.d0
	  hh(ipar) = hh(ipar) + h1 * xlm( f,iabs(g),rtheta )
     &	                           * dcos( dble(iabs(g))*rphi )
     &	                      + h2 * xlm( f,iabs(g),rtheta )
     &	                           * dsin( dble(iabs(g))*rphi )
  100	continue
  110	continue
c computing the model at each grid points
	r = rmax - dep
	if ( ( r.ge.0.d0 ).and.( r.le.rmax ) ) then
	  call calpm( 10,PREM_vrmin,PREM_vrmax,PREM_vs,r,rmax,vs0 )
	  call calpm( 10,PREM_vrmin,PREM_vrmax,PREM_rho,r,rmax,rho0 )
	  mu0 = rho0 * vs0 * vs0
	else
	  stop 'Inappropriate depth.'
	endif
c
	pert = 0.d0
	do 130 izpar=1,nzpar-1
	  if ( ( ( r.ge.model_node(izpar) ).and.
     &	         ( r.lt.model_node(izpar+1) )    ).or.
     &	       ( ( izpar.eq.nzpar-1 ).and.
     &	         ( r.eq.model_node(izpar+1) ) )
     &	     ) then
	    zz1 = ( model_node(izpar+1) - r )
     &	          / ( model_node(izpar+1) - model_node(izpar) )
     &	          * mu0
	    zz2 = ( r - model_node(izpar) )
     &	          / ( model_node(izpar+1) - model_node(izpar) )
     &	          * mu0
	    do 120 ipar=(fmin-1)*(fmin+1)+1,fmax*(fmax+2)
	      pert = pert
     &	         + ( dm(ipar,izpar) * zz1 + dm(ipar,izpar+1) * zz2 )
     &	           * hh(ipar)
  120	    continue
	  endif
  130	continue
c
	if ( (pert+mu0).ge.0.d0 ) then
	  rpert = ( dsqrt( (pert+mu0)/rho0 )- vs0 )
     &	          / vs0 * 100.d0
	else
	  rpert = -100.d0
	endif
c
	write(6,*) 'dVsh/Vsh (%)=',rpert
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine calpm( nzone,vrmin,vrmax,m,r,rmax,m0 )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	integer nzone
	real*8 vrmin(*),vrmax(*),m(4,*),r,rmax,m0
	integer izone,i,j
	real*8 coef
c
	izone = 0
	do 100 i=1,nzone
	  if ( ( vrmin(i).le.r ).and.( r.le.vrmax(i) ) ) izone=i
  100	continue
	if ( izone.eq.0 ) stop 'Something is wrong (calpm).'
c
	m0 = 0.d0
	do 110 j=1,4
	  if ( j.eq.1 ) then
	    coef = 1.d0
	  else
	    coef = coef * ( r / rmax )
	  endif
	  m0 = m0 + m(j,izone) * coef
  110	continue
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	real*8 function xlm( l,m,theta )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	real*8 pi
	parameter ( pi=3.1415926535897932d0 )
c
	integer l,m,i
	real*8 theta,x,plgndr,fact,coef
c
	if( (m.lt.0).or.(m.gt.l) ) stop 'bad arguments (xlm)'
	x = dcos( theta )
	fact = 1.d0
	if ( m.ne.0 ) then
	  do 110 i=l-m+1,l+m
	    fact = fact * dble(i)
  110	  continue
	endif
	coef = dsqrt( dble(2*l+1)/(4.d0*pi) / fact )
	xlm = coef * plgndr( l,m,x )
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	real*8 function plgndr( l,m,x )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	integer l,m,ll,i
	real*8 x,pmm,somx2,fact,pmmp1,pll
c
	if( (m.lt.0).or.(m.gt.l).or.(dabs(x).gt.1.d0) )
     &	  stop 'bad arguments (plgndr)'
	pmm = 1.d0
	if ( m.gt.0 ) then
	  somx2 = dsqrt( (1.d0-x) * (1.d0+x) )
	  fact = 1.d0
	  do 11 i=1,m
	    pmm = - pmm * fact * somx2
	    fact = fact + 2.d0
   11	  continue
	endif
	if( l.eq.m ) then
	  plgndr = pmm
	else
	  pmmp1 = x * dble(2*m+1) * pmm
	  if( l.eq.m+1 ) then
	    plgndr=pmmp1
	  else
	    do 12 ll=m+2,l
	      pll = ( x * dble(2*ll-1) * pmmp1
     &	                - dble(ll+m-1) * pmm )
     &	            / dble(ll-m)
	      pmm = pmmp1
	      pmmp1 = pll
   12	    continue
	    plgndr = pll
	  endif
	endif
c
      return
      end
